<?php
/*
 * Joomla VirtueMart
 * Модуль для подключения платежной системы IntellectMoney
 *
Last Changed Rev: 13318
Last Changed Date: 2011-12-14 17:08:01 +0400 (Wed, 14 Dec 2011)
 */
?>
<?php
if( !defined( '_VALID_MOS' ) && !defined( '_JEXEC' ) ) die( 'Direct Access to '.basename(__FILE__).' is not allowed.' );
/**
 *
 * @version $Id: ps_im.php,v 1.0 beta 2008/04/02 14:10:18 esmark Exp $
 * @package VirtueMart
 * @subpackage payment
 * @copyright Copyright (C) 2004-2005 Soeren Eberhardt. All rights reserved.
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
 * VirtueMart is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 * See /administrator/components/com_virtuemart/COPYRIGHT.php for copyright notices and details.
 *
 * http://virtuemart.ru
 */

class ps_im
{
	var $classname = "ps_im";
	var $payment_code = "IM";

	/**
	 * Show all configuration parameters for this payment method
	 * @returns boolean False when the Payment method has no configration
	 */
	function show_configuration()
	{
		global $VM_LANG;
		require_once(CLASSPATH ."payment/".$this->classname.".cfg.php");
		
		$db = new ps_DB();
		$q = "SELECT order_status_name,order_status_code FROM #__{vm}_order_status ORDER BY list_order";
		$db->query($q);
		$order_status_code = Array();
		$order_status_name = Array();

		while ($db->next_record()) {
			$order_status_code[] = $db->f("order_status_code");
			$order_status_name[] = $db->f("order_status_name");
		}
		
		for ($i=0; $i < sizeof($order_status_code); $i++) {
			$options1 .= '<option value="' . $order_status_code[$i];
			$options1 .= (PAYPAL_VERIFIED_STATUS == $order_status_code[$i]) ? '" selected="selected">' : '">';
			$options1 .= $order_status_name[$i];
			$options1 .= '</option>\n';
		}
		
		for ($i=0; $i < sizeof($order_status_code); $i++) {
			$options2 .= '<option value="' . $order_status_code[$i];
			$options2 .= (PAYPAL_PENDING_STATUS == $order_status_code[$i]) ? '" selected="selected">' : '">';
			$options2 .= $order_status_name[$i];
			$options2 .= '</option>\n';
		}
		/**/
		$file_arg = simplexml_load_file("http://www.cbr.ru/scripts/XML_daily.asp?date_req=".date("d/m/Y"));

		$valutes = array();
		$valutes_selector = '';
		foreach ($file_arg AS $el){
			$valutes_selector .= '<option ' . ((@IM_TRANSFER == (string)$el->attributes()->ID) ? 'selected="selected"' : '') .' value="'.(string)$el->attributes()->ID.'">Из '.strval($el->CharCode).' в RUB</option>';
			$valutes[(string)$el->attributes()->ID] = array('code'=>strval($el->CharCode),'value'=>strval($el->Value));
		}
		//print_r($valutes);
		/**/
		$html = '
			<table class="adminform">
				<tr class="row1">
					<td><b>Номер магазина продавца</b></td>
					<td>
						<input type="text" name="IM_ESHOP_ID" class="inputbox" value="'.IM_ESHOP_ID.'" />
					</td>
				</tr>
				<tr class="row0">
					<td><b>Номер кошелька продавца</b></td>
					<td>
						<input type="text" name="IM_ACCOUNT_ID" class="inputbox" value="'.IM_ACCOUNT_ID.'" />
					</td>
				</tr>
				<tr class="row1">
					<td><b>Секретное слово</b></td>
					<td>
						<input type="text" name="IM_SECRET_KEY" class="inputbox" value="'.IM_SECRET_KEY.'" />
					</td>
				</tr>
				<tr class="row0">
					<td><strong>'.$VM_LANG->_("PHPSHOP_ADMIN_CFG_ENABLE_AUTORIZENET_TESTMODE").'</strong></td>
					<td>
						<select name="PAYPAL_DEBUG" class="inputbox" >
							<option ' . ((@PAYPAL_DEBUG == "1") ? 'selected="selected"' : '') .' value="1">'.$VM_LANG->_("PHPSHOP_ADMIN_CFG_YES"). '</option>
							<option ' . ((@PAYPAL_DEBUG != "1") ? 'selected="selected"' : '') .' value="0">'.$VM_LANG->_("PHPSHOP_ADMIN_CFG_NO"). '</option>
						</select>
					</td>
					<td>Когда включено, позволяет протестировать Ваш файл уведомлений</td>
				</tr>
				<tr class="row1">
					<td><strong>Конвертировать в рубли по курсу ЦБ</strong></td>
					<td>
						<select name="IM_TRANSFER" class="inputbox" >
							<option ' . ((@IM_TRANSFER == "0") ? 'selected="selected"' : '') .' value="0">Нет</option>
							'.$valutes_selector.'
						</select>
					</td>
					<td>Когда включено, производится конвертация единицы оплаты в рубли по курсу выбранной валюты по данным ЦБ РФ на момент выставления счета</td>
				</tr>				
				<tr class="row0">
					<td><strong>'.$VM_LANG->_("PHPSHOP_ADMIN_CFG_PAYPAL_STATUS_SUCCESS").'</strong></td>
					<td>
						<select name="PAYPAL_VERIFIED_STATUS" class="inputbox" >
							'.$options1.'
						</select>
					</td>
					<td>'.$VM_LANG->_("PHPSHOP_ADMIN_CFG_PAYPAL_STATUS_SUCCESS_EXPLAIN").'</td>
				</tr>
				<tr class="row1">
					<td><strong>'.$VM_LANG->_("VM_ADMIN_CFG_PAYPAL_STATUS_PENDING").'</strong></td>
					<td>
						<select name="PAYPAL_PENDING_STATUS" class="inputbox" >
							'.$options2.'
						</select>
					</td>
					<td>'.$VM_LANG->_("VM_ADMIN_CFG_PAYPAL_STATUS_PENDING_EXPLAIN").'</td>
				</tr>
			</table>';
		echo $html;
	}

	function has_configuration()
	{
		// return false if there's no configuration
		return true;
	}

	/**
	 * Returns the "is_writeable" status of the configuration file
	 * @param void
	 * @returns boolean True when the configuration file is writeable, false when not
	 */
	function configfile_writeable()
	{
		return is_writeable( CLASSPATH."payment/".$this->classname.".cfg.php" );
	}

	/**
	 * Returns the "is_readable" status of the configuration file
	 * @param void
	 * @returns boolean True when the configuration file is writeable, false when not
	 */
	function configfile_readable()
	{
		return is_readable( CLASSPATH."payment/".$this->classname.".cfg.php" );
	}

	/**
	 * Writes the configuration file for this payment method
	 * @param array An array of objects
	 * @returns boolean True when writing was successful
	 */
	function write_configuration( &$d )
	{
		$my_config_array = array(
			"IM_ESHOP_ID" => $d['IM_ESHOP_ID'],
			"IM_ACCOUNT_ID" => $d['IM_ACCOUNT_ID'],
			"IM_SECRET_KEY" => $d['IM_SECRET_KEY'],
			"IM_TRANSFER" => $d['IM_TRANSFER'],
			"PAYPAL_DEBUG" => $d['PAYPAL_DEBUG'],
			"PAYPAL_VERIFIED_STATUS" => $d['PAYPAL_VERIFIED_STATUS'],
			"PAYPAL_PENDING_STATUS" => $d['PAYPAL_PENDING_STATUS']
		);
		$config = "<?php\n";
		$config .= "if( !defined( '_VALID_MOS' ) && !defined( '_JEXEC' ) ) die( 'Direct Access to '.basename(__FILE__).' is not allowed.' );\n\n";
		foreach( $my_config_array as $key => $value )
			$config .= "define ('$key', '$value');\n";
		$config .= "?>";

		if ($fp = fopen(CLASSPATH ."payment/".$this->classname.".cfg.php", "w")) {
			fputs($fp, $config, strlen($config));
			fclose ($fp);
			return true;
		}
		else {
			$vmLogger->err( "Ошибка записи файла конфигурации. Проверьте права на запись файла." );
			return false;
		}
	}

	/**************************************************************************
	 ** name: process_payment()
	 ** returns:
	 ***************************************************************************/
	function process_payment($order_number, $order_total, &$d)
	{
		return true;
	}

	/**************************************************************************
	 ** name: get_currency()
	 ** @param string currency code RUR|UAH|EUR|USD on else false
	 ** returns: html code on true or false if there is some errors
	 ***************************************************************************/
	function get_currency($val)
	{
		return (@PAYPAL_DEBUG == "1") ? 'TST' : 'RUB';
	}
	
	function str2num($str){ 
	  if(strpos($str, '.') < strpos($str,',')){ 
				$str = str_replace('.','',$str); 
				$str = strtr($str,',','.');            
			} 
			else{ 
				$str = str_replace(',','',$str);            
			} 
			return (float)$str; 
	} 	
	
	function get_amount($val)
	{
		/**/
		if(@IM_TRANSFER != '0') 
		{
			$file_arg = simplexml_load_file("http://www.cbr.ru/scripts/XML_daily.asp?date_req=".date("d/m/Y"));

			$valutes = array();			
			foreach ($file_arg AS $el){
				if(@IM_TRANSFER == (string)$el->attributes()->ID) 
					return array(0=>number_format($this->str2num($el->Value), 2, '.', ''), 1=>number_format((number_format($this->str2num($el->Value), 2, '.', '') * $val), 2, '.', ''));
			}
			return array(0=>'',1=>'');
		}else return array(0=>'1',1=>$val);
		//print_r($valutes);
		/**/	
	}
}